;
$DATE (23.08.2004)
$TITLE (TATest.a51)
$PAGELENGTH(56)
$PAGEWIDTH(150)
$DEBUG
$XREF
$NOLIST
$NOMOD51
$INCLUDE(89S8252.MCU)
$LIST
;
;********************************************************************************************************
; Testprogramm fr Tastatur und Anzeige
; J. Rathlev, Aug. 2004
;********************************************************************************************************

      NAME      TATest

;********************************************************************************************************
; Konstanten
; ==========

LED     EQU     P1.7   ; Portanschluss fr LED

CODEMEM EQU     8000H

                
;********************************************************************************************************
; RAM-Daten
; =========

        DSEG    AT      30H

;********************************************************************************************************
; Programmstart

        CSEG    AT      CODEMEM

        LJMP    Start
        
;********************************************************************************************************

        ORG     CODEMEM+30H

$INCLUDE(Includes\i2c.a51)
$INCLUDE(Includes\Tast3x4.a51)
$INCLUDE(Includes\Display-162.a51)
$INCLUDE(Includes\Display.a51)
$INCLUDE(Includes\SerInOut.a51)

;********************************************************************************************************
; Hauptprogramm

Start:  MOV     SP,#STACKSTART
        CALL    InitDisplay
        CLR     A
        CALL    InitKey
        MOV     A,#244          ; BR-Count 9600 (SerInOut.a51)
        CALL    InitSerial
        CALL    InitSerInput
        SETB    EA              ; Enable Global-Interrupt
        MOV     DPTR,#Text2
        CALL    WDStr

LOOP:   CALL    GetKey
        JNC     LOOP            ; keine Eingabe
;        CPL     LED        
        MOV     R0,A
        CALL    WRITECHAR       ; an Serial-Port
        CALL    WriteCr
             
        MOV     A,#0
        CALL    SDLine

        MOV     DPTR,#Text1
        CALL    WDStr

        MOV     A,R0
        CALL    WDChar          ; an Anzeige

        SJMP    LOOP            ; Endlosschleife

Text1:  DB      'Eingabe: ',0
Text2:  DB      'Warte ...',0

;********************************************************************************************************
        DSEG

STACKSTART:
        DS      1       ; stack: rest of data memory

END
